#include<config.h>
#include<Ecore_Evas.h>
#include<Ecore_Config.h>
#include<Ecore_File.h>
#include<Esmart/Esmart_Container.h>
#include<Ewl.h>
#include"ewl_context_menu.h"
#include"Elitaire.h"

struct Eli_App {
	Ecore_Evas* 	ee;
	Evas_Object*	elitaire;
	Evas*		evas;
	Evas_Object*	gui;
	struct {
		struct{
			char* current;
			Ecore_List* list;
		}gui,cards;
	} theme;
	Ewl_Widget*	conmenu;
};

/* The Config Types */
enum Config_Types{
	THEME,
	CARDS,
	VELOCITY,
	SHADOWS,
	ANIMATIONS,
	FRAME_RATE
};

/* eli_app.cpp */
Eli_App* 	eli_app_new(void);
void 		eli_app_init(Eli_App* eap);
void 		eli_app_del(Eli_App* eap);

/* gui.cpp */
void 		eli_app_gui_make(Eli_App* eap);
void 		eli_app_gui_del(Eli_App* eap);
void		eli_app_gui_resize(Eli_App* eap,int w,int h);
/* menu.cpp */
void 		eli_app_menu_container_fill(Eli_App * eap, Evas_Object * container);
void 		eli_app_new_game(Eli_App * eap, const char * game);
void 		eli_app_velocity_set(Eli_App * eap, int velocity);
int  		eli_app_velocity_get(Eli_App * eap);
/* theme.cpp */
Evas_Bool	edje_file_group_exists(const char * file, const char * group);
void		eli_app_theme_init(Eli_App * eap);
Ecore_List* 	eli_app_theme_names_get();
Ecore_List* 	eli_app_theme_dir_get();
void 		eli_app_theme_change(Eli_App* eap, char * theme);
void 		eli_app_theme_container_fill(Eli_App * eap, Evas_Object * container);
void 		eli_app_cards_container_fill(Eli_App * eap, Evas_Object * container);
Evas_Bool 	eli_app_theme_gui_exists(Eli_App * eap, const char * theme);
Evas_Bool 	eli_app_theme_cards_exists(Eli_App * eap, const char * theme);

/*config_window.cpp */
void		eli_app_config_window_open(Eli_App * eap);
/*about.cpp */
void		eli_app_about_open(Eli_App * eap);
/* conmenu.cpp */
Ewl_Widget* 	eli_conmenu_new(Eli_App * eap);
/* eli_config.cpp */
void 		eli_app_config_init(Eli_App * eap);

#define	eli_app_velocity_percent_to_real(percent) (200 + (int) (1800 * (percent)))
#define eli_app_velocity_real_to_percent(vel) (( (double) ((vel) - 200) )/1800.0)
#define eli_app_frame_rate_real_to_percent(fr) (( (double) ((fr) - 10) )/ 190.0)
#define	eli_app_frame_rate_percent_to_real(percent) (10 + (int) (190.0 * (percent)))
