#include"playingCard.h"
#include<Ecore.h>
#include<Evas.h>
#include<Edje.h>
#include"intl.h"

struct Elitaire{
	
	Evas*		evas;
	cardGame* 	game;
	char*		file;
	int		velocity;
	float		spacing;
	float		margin_h;
	float		margin_v;
	Evas_Coord	x,y,w,h;
	int		max_cols; /* highest number of cards in a row */ 
	int 		num_rows;
	int		num_stacks;
	int		num_cards;
	int		frame_rate;	/* pics per sec */
	Evas_Bool	deal;
	Evas_Bool	animate;
	Evas_Bool	shadow;
	
	Evas_Coord	card_w, card_h;
	Evas_Coord	card_max_w,card_max_h;
	Evas_Coord	card_min_w,card_min_h;
	Evas_Object**	stacks;
	Evas_Object*	clip;
	
};

/* external API */
const char **   elitaire_available_games_get(void);
Evas_Object *	elitaire_new(Evas* evas, const char * game);
int		elitaire_file_set(Evas_Object * elitaire,  char *file);
int		elitaire_file_get(Evas_Object * elitaire,  char **file);
void		elitaire_deal(Evas_Object * elitaire);
int		elitaire_velocity_get(Evas_Object * elitaire);
void		elitaire_velocity_set(Evas_Object * elitaire, int v);
void		elitaire_frame_rate_set(Evas_Object * elitaire, int fr);
int		elitaire_frame_rate_get(Evas_Object * elitaire);
void		elitaire_animations_set(Evas_Object * elitaire, Evas_Bool on);
Evas_Bool	elitaire_animations_get(Evas_Object * elitaire);
void		elitaire_shadows_set(Evas_Object * elitaire, Evas_Bool on);
Evas_Bool	elitaire_shadows_get(Evas_Object * elitaire);
void		elitaire_size_min_get(Evas_Object * elitaire, Evas_Coord *minw, Evas_Coord *minh);
void		elitaire_size_max_get(Evas_Object * elitaire, Evas_Coord *maxw, Evas_Coord *maxh);
void		elitaire_win_callback_add(Evas_Object * elitaire, void (*func)(int win, void* data), void* data);
void 		elitaire_points_callback_add(Evas_Object * elitaire, 
						void (*func)(float points, pointsType type, void* data), 
						void* data);
void 		elitaire_undo(Evas_Object* elitaire);

/* other useful stuff */
char* itoa(int val, char* buf, int length);

/* also in elitaire_card.c  needed */
void 		elitaire_stack_layer_reinit(Elitaire* eli, cardStack* stack);
int 		elitaire_clicked_stack_get(Elitaire* eli, Evas_Coord x, Evas_Coord y);
Evas_Coord	_elitaire_card_offset_get(Elitaire * eli);
Evas_Coord	_elitaire_card_offset_calc(Elitaire * eli,Evas_Coord h);
Evas_Coord 	_elitaire_spacing_abs_calc(Elitaire * eli, int row);
void 		_elitaire_mouse_up_cb(void *data, Evas *e, Evas_Object *obj, void *event_info);
void 		_elitaire_mouse_down_cb(void *data, Evas *e, Evas_Object *obj, void *event_info);
void 		_elitaire_reinit(Elitaire* eli);

#include"elitaire_card.h"
