#include"Eli_App.h"

void _about_destroy_cb(Ewl_Widget *w, void *event, void *data);

void eli_app_about_open(Eli_App * eap)
{
	Ewl_Widget * win;
	Ewl_Widget * o;
	char * text;
	
	/* Setup and show the about window */
        win = ewl_dialog_new(EWL_POSITION_BOTTOM);
	ewl_window_title_set(EWL_WINDOW(win), "Elitaire: About");
	ewl_window_name_set (EWL_WINDOW(win), "Elitaire");
	ewl_window_class_set(EWL_WINDOW(win), "Elitaire");
        ewl_object_size_request(EWL_OBJECT(win), 200, 200);
	ewl_callback_append(win, EWL_CALLBACK_DELETE_WINDOW, _about_destroy_cb, win);
	ewl_dialog_has_separator_set(EWL_DIALOG(win), 1);
	ewl_object_fill_policy_set(EWL_OBJECT(win), EWL_FLAG_FILL_FILL);
        ewl_widget_show(win);
	
        /* Setup and show the stock icons*/
        o = 	ewl_dialog_button_add(EWL_DIALOG(win),EWL_STOCK_OK, 0);
		ewl_container_child_append(EWL_CONTAINER(win), o);
		ewl_callback_append(o, EWL_CALLBACK_CLICKED, _about_destroy_cb, win);
		ewl_widget_show(o);
	
	asprintf(&text, _("%s version %s\n\nAuthor:\n  %s\n"
			"  %s\n  %s\n\nThanks to:\n  %s\n  %s"), 
			PACKAGE_NAME, 
			PACKAGE_VERSION, 
			"Peter Wehrfritz",
			"peter.wehrfritz@web.de",
			"www.mowem.de/elitaire",
			"The Enlightenment Project",
			"www.enlightenment.org"
			);
			
	/* Textbox */
	o =	ewl_text_new( text );
		ewl_dialog_widget_add(EWL_DIALOG(win), o);
		ewl_object_fill_policy_set(EWL_OBJECT(o), EWL_FLAG_FILL_FILL);
		//ewl_object_alignment_set(EWL_OBJECT(o), EWL_FLAG_ALIGN_CENTER);
		ewl_text_align_set(EWL_TEXT(o), EWL_FLAG_ALIGN_CENTER);
		
		ewl_object_padding_set(EWL_OBJECT(o),15,15,15,15);
		ewl_widget_show(o);
				
	free(text);	
}

void _about_destroy_cb(Ewl_Widget *w, void *event, void *data)
{
	Ewl_Widget * win;
	
	win = (Ewl_Widget*) data;
	ewl_widget_destroy(win);
}
