#include"Eli_App.h"

void destroy_cb(Ewl_Widget *w, void *event, void *data);
void conf_win_clicked_cb(Ewl_Widget *w, void *event, void *data);
void _check_selected(Ewl_Widget * w, void * event, void * data);
void _hseeker_cb(Ewl_Widget * w, void * event, void * data);

static Ewl_Widget * conf_win;
static struct {
	Evas_Bool	shadows;
	Evas_Bool	animations;
	Evas_Bool	gl;
	Ewl_Widget *	vel_label;
	Ewl_Widget *	frt_label;
	int		velocity;
	int		frame_rate;
} config;

void eli_app_config_window_open(Eli_App * eap)
{
	Ewl_Widget *o;
	Ewl_Widget *border_box;
	Ewl_Widget *hbox;
	Ewl_Widget *main_box;
	Ewl_Widget *radio_b[2];
		
	/* Setup and show the configuration window */
        conf_win = ewl_dialog_new(EWL_POSITION_BOTTOM);
	ewl_window_title_set(EWL_WINDOW(conf_win), "Elitaire: Configuration");
	ewl_window_name_set (EWL_WINDOW(conf_win), "Elitaire");
	ewl_window_class_set(EWL_WINDOW(conf_win), "Elitaire");
        //ewl_object_size_request(EWL_OBJECT(conf_win), 200, 200);
	ewl_callback_append(conf_win, EWL_CALLBACK_DELETE_WINDOW, destroy_cb, NULL);
	ewl_dialog_has_separator_set(EWL_DIALOG(conf_win), 1);
	ewl_object_fill_policy_set(EWL_OBJECT(conf_win), EWL_FLAG_FILL_FILL);
	//ewl_object_alignment_set(EWL_OBJECT(conf_win), EWL_FLAG_ALIGN_CENTER);
        ewl_widget_show(conf_win);
	/* the main_box contain the border_boxes */
	main_box = ewl_hbox_new();
		ewl_dialog_widget_add(EWL_DIALOG(conf_win), main_box);
		//ewl_object_fill_policy_set(EWL_OBJECT(main_box), EWL_FLAG_FILL_ALL);
		ewl_object_fill_policy_set(EWL_OBJECT(main_box), EWL_FLAG_ALIGN_CENTER);
		ewl_widget_show(main_box);
	
        /* Setup and show the stock icons*/
        o = 	ewl_dialog_button_add(EWL_DIALOG(conf_win),EWL_STOCK_CANCEL, 2);
		ewl_container_child_append(EWL_CONTAINER(conf_win), o);
		ewl_callback_append(o, EWL_CALLBACK_CLICKED, conf_win_clicked_cb, conf_win);
		ewl_widget_show(o);
	
	o = 	ewl_dialog_button_left_add(EWL_DIALOG(conf_win),EWL_STOCK_APPLY, 3);
		ewl_container_child_append(EWL_CONTAINER(conf_win), o);
		ewl_callback_append(o, EWL_CALLBACK_CLICKED, conf_win_clicked_cb, conf_win);
		ewl_widget_show(o);
	
	o = 	ewl_dialog_button_left_add(EWL_DIALOG(conf_win),EWL_STOCK_OK, 1);
		ewl_container_child_append(EWL_CONTAINER(conf_win), o);
		ewl_callback_append(o, EWL_CALLBACK_CLICKED, conf_win_clicked_cb, conf_win);
		ewl_widget_show(o);
		
	/* *** Graphic Box *** */
	/* Setup and show the border box */
	border_box = ewl_border_new( _("Graphic"));
		ewl_container_child_append(EWL_CONTAINER(main_box), border_box);
		ewl_object_fill_policy_set(EWL_OBJECT(border_box), EWL_FLAG_FILL_VFILL);
		ewl_object_alignment_set(EWL_OBJECT(border_box), EWL_FLAG_ALIGN_CENTER);
		ewl_object_alignment_set(EWL_OBJECT(main_box), EWL_FLAG_ALIGN_TOP);
		ewl_object_padding_set(EWL_OBJECT(border_box),15,15,15,15);
		ewl_widget_show(border_box);
	/* Setup and show the checkbuttons */
	o = 	ewl_checkbutton_new( _("animated movements"));
		ewl_container_child_append(EWL_CONTAINER(border_box),o);
		ewl_widget_show(o);
		config.animations = ecore_config_boolean_get("/graphic/animations");
		ewl_checkbutton_checked_set(o,config.animations);
		ewl_callback_append(o, EWL_CALLBACK_CLICKED, _check_selected, NULL);
	
	o = 	ewl_checkbutton_new( _("shadows"));
		ewl_container_child_append(EWL_CONTAINER(border_box),o);
		ewl_widget_show(o);
		config.shadows = ecore_config_boolean_get("/graphic/shadows");
		ewl_checkbutton_checked_set(o,config.shadows);
		ewl_callback_append(o, EWL_CALLBACK_CLICKED, _check_selected, NULL);
	
	/* Setup and show the velocity label and seeker */
	hbox = 	ewl_hbox_new();
		ewl_container_child_append(EWL_CONTAINER(border_box),hbox);
		ewl_object_fill_policy_set(EWL_OBJECT(hbox), EWL_FLAG_FILL_FILL);
		ewl_widget_show(hbox);
		
	o =	ewl_text_new( _("velocity:"));
		ewl_container_child_append(EWL_CONTAINER(hbox),o);
		ewl_object_alignment_set(EWL_OBJECT(o), EWL_FLAG_ALIGN_LEFT);
		//ewl_object_fill_policy_set(EWL_OBJECT(o), EWL_FLAG_FILL_FILL);
		ewl_widget_show(o);
		
	o =	ewl_text_new("");
		ewl_container_child_append(EWL_CONTAINER(hbox),o);
		ewl_object_alignment_set(EWL_OBJECT(o), EWL_FLAG_ALIGN_RIGHT);
		ewl_text_align_set(EWL_TEXT(o), EWL_FLAG_ALIGN_RIGHT);
		ewl_widget_show(o);
	config.vel_label = o;
		
	o =	ewl_hseeker_new();
		config.velocity = ecore_config_int_get("velocity");
		ewl_seeker_value_set(EWL_SEEKER(o), eli_app_velocity_real_to_percent(config.velocity)*100);
		ewl_widget_name_set(o,"velocity");
		ewl_container_child_append(EWL_CONTAINER(border_box),o);
		ewl_callback_append(o, EWL_CALLBACK_VALUE_CHANGED, _hseeker_cb, NULL);
		_hseeker_cb(o,NULL,NULL);
		ewl_widget_show(o);
	
	/* Setup and show the frame_rate label and seeker */
	hbox = 	ewl_hbox_new();
		ewl_container_child_append(EWL_CONTAINER(border_box),hbox);
		ewl_object_fill_policy_set(EWL_OBJECT(hbox), EWL_FLAG_FILL_ALL);
		ewl_widget_show(hbox);
		
	o =	ewl_text_new( _("frame rate:"));
		ewl_container_child_append(EWL_CONTAINER(hbox),o);
		//ewl_object_alignment_set(EWL_OBJECT(o), EWL_FLAG_ALIGN_LEFT);
		ewl_object_fill_policy_set(EWL_OBJECT(o), EWL_FLAG_FILL_ALL);
		ewl_widget_show(o);
		
	o =	ewl_text_new("");
		ewl_container_child_append(EWL_CONTAINER(hbox),o);
		//ewl_object_alignment_set(EWL_OBJECT(o), EWL_FLAG_ALIGN_RIGHT);
		ewl_text_align_set(EWL_TEXT(o), EWL_FLAG_ALIGN_RIGHT);
		ewl_object_fill_policy_set(EWL_OBJECT(o), EWL_FLAG_FILL_ALL);
		ewl_widget_show(o);
	config.frt_label = o;
		
	o =	ewl_hseeker_new();
		config.frame_rate = ecore_config_int_get("frame_rate");
		ewl_seeker_value_set(EWL_SEEKER(o), eli_app_frame_rate_real_to_percent(config.frame_rate)*100);
		ewl_widget_name_set(o,"frame_rate");
		ewl_container_child_append(EWL_CONTAINER(border_box),o);
		ewl_callback_append(o, EWL_CALLBACK_VALUE_CHANGED, _hseeker_cb, NULL);
		_hseeker_cb(o,NULL,NULL);
		ewl_widget_show(o);
	
	/* *** Render Box *** */
	/* Setup and show the border box */
	border_box = ewl_border_new( _("Render Engine"));
		ewl_container_child_append(EWL_CONTAINER(main_box), border_box);
		ewl_object_fill_policy_set(EWL_OBJECT(border_box), EWL_FLAG_FILL_VFILL);
		ewl_object_alignment_set(EWL_OBJECT(border_box), EWL_FLAG_ALIGN_CENTER);
		ewl_object_alignment_set(EWL_OBJECT(main_box), EWL_FLAG_ALIGN_TOP);
		ewl_object_padding_set(EWL_OBJECT(border_box),15,15,15,15);
		ewl_widget_show(border_box);
		
	o =	ewl_text_new( _("Changes only affect after new start"));
		ewl_container_child_append(EWL_CONTAINER(border_box),o);
		ewl_widget_show(o);
	
	/* the radio buttons */
	radio_b[0] = ewl_radiobutton_new( _("Software"));
		ewl_container_child_append(EWL_CONTAINER(border_box), radio_b[0]);
		ewl_callback_append(radio_b[0], EWL_CALLBACK_CLICKED, _check_selected, NULL);
		ewl_widget_show(radio_b[0]);
	
	radio_b[1] = ewl_radiobutton_new( _("OpenGL (testing)"));
		ewl_container_child_append(EWL_CONTAINER(border_box), radio_b[1]);
		ewl_radiobutton_chain_set(EWL_RADIOBUTTON(radio_b[1]),EWL_RADIOBUTTON(radio_b[0]));
		ewl_callback_append(radio_b[1], EWL_CALLBACK_CLICKED, _check_selected, NULL);
		ewl_widget_show(radio_b[1]);
	if( ecore_config_boolean_get("/graphic/gl")) ewl_checkbutton_checked_set(radio_b[1],1);
	else ewl_checkbutton_checked_set(radio_b[0],1);
	
}

void destroy_cb(Ewl_Widget *w, void *event, void *data)
{
	ewl_widget_destroy(w);
}

void conf_win_clicked_cb(Ewl_Widget *w, void *event, void *data)
{
	int d = EWL_BUTTON_STOCK(w)->response_id;
	
	if (d == 1 || d == 3){ 
		ecore_config_boolean_set("/graphic/animations", config.animations);
		ecore_config_boolean_set("/graphic/shadows", config.shadows);
		ecore_config_boolean_set("/graphic/gl", config.gl);
		ecore_config_int_set("velocity", config.velocity);
		ecore_config_int_set("frame_rate", config.frame_rate);
		
		if(ecore_config_save() != ECORE_CONFIG_ERR_SUCC) 
			fprintf(stderr, _("Elitaire Error: Could not save configuration.\n"));
	}
	
	if (d == 1 || d == 2) ewl_widget_destroy(EWL_WIDGET(data));
}

void _check_selected(Ewl_Widget * w, void * event, void * data)
{
	char * label;
	label = ewl_button_label_get(EWL_BUTTON(w));
	
	if(!strcmp(label, _("animated movements"))){
		config.animations = ewl_checkbutton_is_checked(w);
	}
	else if(!strcmp(label, _("shadows") )){
		config.shadows = ewl_checkbutton_is_checked(w);
	}
	else if(!strcmp(label, _("Software") )){
		config.gl = !ewl_radiobutton_is_checked(w);
	}
	else if(!strcmp(label, _("OpenGL (testing)") )){
		config.gl = ewl_radiobutton_is_checked(w);
	}
}

void _hseeker_cb(Ewl_Widget * w, void * event, void * data)
{
	double value;
	char * buffer;
	const char* name;
	
	value = ewl_seeker_value_get(EWL_SEEKER(w));
	
	name = ewl_widget_name_get(w);
	if(!strcmp(name, "velocity")){
		config.velocity = eli_app_velocity_percent_to_real(value/100);
		
		asprintf( &buffer, "%i", config.velocity);
		ewl_text_text_set(EWL_TEXT(config.vel_label), buffer);
		
		free(buffer);
	}
	else if(!strcmp(name, "frame_rate")){
		
		config.frame_rate = eli_app_frame_rate_percent_to_real(value/100);
		
		asprintf( &buffer, "%i", config.frame_rate);
		ewl_text_text_set(EWL_TEXT(config.frt_label), buffer);
		
		free(buffer);		
	}
}
