#include"Eli_App.h"

/* internals */
void win_del_cb(Ecore_Evas *ee);
void win_resize_cb(Ecore_Evas *ee);
void _eli_app_ee_init(Eli_App * eap);
void _eli_app_config_init(Eli_App *eap);

/* allocate memory for eap */
Eli_App* eli_app_new(void){
	Eli_App * eap;
	eap = (Eli_App*) malloc(sizeof(Eli_App));
	eap->gui = NULL;
	eap->evas = NULL;
	eap->ee = NULL;
	eap->elitaire = NULL;
	
	return eap;
}

/* init configs and theme stuff*/
void eli_app_init(Eli_App * eap)
{	
	ecore_config_theme_search_path_append(PACKAGE_DATA_DIR"/themes/");
	
	eli_app_theme_init(eap);
	eli_app_config_init(eap);
	
	
	
	_eli_app_ee_init(eap);
	eap->conmenu = eli_conmenu_new(eap);
}

void eli_app_del(Eli_App * eap)
{
	if(eap->elitaire) evas_object_del(eap->elitaire);
	
	ecore_config_theme_set("/theme/gui",eap->theme.gui.current);
	ecore_config_theme_set("/theme/cards",eap->theme.cards.current);
	
	ecore_config_save();
}

/* init Ecore_Evas stuff */
void _eli_app_ee_init(Eli_App * eap)
{
	Ecore_Evas* ee;
	
	if( ecore_config_boolean_get("/graphic/gl") && 
	    ecore_evas_engine_type_supported_get(ECORE_EVAS_ENGINE_GL_X11)){
		
		ee = ecore_evas_gl_x11_new(NULL,0,0,0,0,0);
	}
	else ee = ecore_evas_software_x11_new(NULL,0,0,0,0,0);
	
	ecore_evas_title_set(ee, "Elitaire");
	ecore_evas_name_class_set(ee, "Elitaire", "Elitaire");
	ecore_evas_data_set(ee, "eap", eap);
	
	ecore_evas_show(ee);
	ecore_evas_callback_delete_request_set(ee, win_del_cb);
	ecore_evas_callback_resize_set(ee, win_resize_cb);
	
	eap->evas = ecore_evas_get(ee);
	eap->ee = ee;
}



/* two callbacks */
void win_del_cb(Ecore_Evas *ee)
{
	ecore_main_loop_quit();
}

void win_resize_cb(Ecore_Evas *ee)
{
	if (ee) {
		Evas_Coord w, h;
		Eli_App* eap;
		
		ecore_evas_geometry_get(ee, NULL, NULL, &w, &h);
		eap = (Eli_App*) ecore_evas_data_get(ee,"eap");
		eli_app_gui_resize(eap,w,h);
	}
}
