/**************************************************************************
 * An evas smart object template
 * 
 * Replace all instances of _elitaire_card with the function prefix for your object
 * Replace all instances of Elitaire_Card with the name of you smart data struct
 *
 ***************************************************************************/

/*** enum for the different kinds of jobs ***/
enum _Card_Job_Type {
	SLIDE,
	DEL_CHAIN,
	FLIP,
	DRAGGED,
	DRAG,
	DROP,
	WAIT,
	FADE_IN,
	FADE_OUT
};

/*** the struct for the slides and other time based movements ***/
struct _Elitaire_Card_Job{
	Evas_Coord x,y;
	Ecore_Timer* timer;
	_Elitaire_Card_Job* next_job;
	_Card_Job_Type type;
};

/*** the data struct ***/
struct Elitaire_Card{
	Evas_Object *image, *next_card, *shadow;
	playingCard* pcard;
	Elitaire * eli;
	_Elitaire_Card_Job* job;
};
/*** external API ***/

Evas_Object * 	elitaire_card_new(Elitaire *eli, playingCard* pcard);
//void		elitaire_card_next_card_set(Evas_Object* o, Evas_Object* ncard);
Evas_Object *	elitaire_card_next_card_get(Evas_Object* o);
void		elitaire_card_playingCard_set(Evas_Object* o, playingCard* pcard);
playingCard * 	elitaire_card_playingCard_get(Evas_Object* o);
void		elitaire_card_callback_add(Evas_Object* card, Evas_Callback_Type type, 
					void(*func)(void *data, Evas *e, Evas_Object *obj, void *event_info));
Evas_Bool	elitaire_card_moveable(Evas_Object* card);
Evas_Object *	elitaire_card_card_find(Elitaire* eli,Evas_Object* image); /* this function return the elitaire_card by giving it its image */
Elitaire    *  	elitaire_card_elitaire_get(Evas_Object* card);
void		elitaire_card_chain_make(Evas_Object* card);
void		elitaire_card_chain_del(Evas_Object* card);
void		elitaire_card_reinit(Evas_Object* card);
void 		elitaire_card_slide(Evas_Object* card, Evas_Coord x, Evas_Coord y);
void		elitaire_card_flip(Evas_Object* card);
void		elitaire_card_dragged(Evas_Object* card);
void 		elitaire_card_fade(Evas_Object * card);
void 		elitaire_card_xy_get(Evas_Object * card, Evas_Coord * x, Evas_Coord * y);


