#include"Eli_App.h"
//#include"Elitaire.h"

void _item_select_cb(Ewl_Widget *w, void *ev_data, void *user_data);
void _add_item(char* text, Ewl_Widget * container, void * data);
void _new_cb(Ewl_Widget *w, void *ev_data, void *user_data);
Ewl_Widget* _new_menu(Eli_App * eap);

Ewl_Widget * eli_conmenu_new(Eli_App * eap)
{

	Ewl_Widget * menu;
	Ewl_Widget * w;
	
	menu = ewl_context_menu_new();
		
	w = _new_menu(eap);
	ewl_container_child_append(EWL_CONTAINER(menu),w);
	_add_item( sgettext( N_("CONTEXT|Undo")) ,menu,eap);
	_add_item( sgettext( N_("CONTEXT|Preferences")),menu,eap);
	_add_item( sgettext( N_("CONTEXT|About")),menu,eap);
	
	
	return EWL_WIDGET(menu);
}

void _add_item(char* text, Ewl_Widget * container, void * data)
{
	Ewl_Widget * w;
	
	w = ewl_menu_item_new(NULL,text);
	ewl_container_child_append(EWL_CONTAINER(container),w);
	ewl_callback_append(w,EWL_CALLBACK_SELECT,_item_select_cb,data);
	ewl_widget_show(w);
}

void _item_select_cb(Ewl_Widget *w, void *ev_data, void *user_data)
{
	char * text;
	Eli_App * eap;
	
	eap = (Eli_App*) user_data;
	
	text = ewl_menu_item_text_get(EWL_MENU_ITEM(w));
	if(!strcmp(text, sgettext( N_("CONTEXT|Undo")))){
		if(eap->elitaire) elitaire_undo(eap->elitaire);
	}
	else if(!strcmp(text, sgettext( N_("CONTEXT|Preferences")))) 
		eli_app_config_window_open(eap);
	else if(!strcmp(text, sgettext( N_("CONTEXT|About"))))
		eli_app_about_open(eap);

	free(text);
}

Ewl_Widget* _new_menu(Eli_App * eap)
{
	const char  ** games;
	Ewl_Widget * menu;
	
	games = elitaire_available_games_get();
	
	menu = ewl_menu_new(NULL, sgettext( N_("CONTEXT|New")));
	
	for(int i = 0;games[i][0];i++){
		Ewl_Widget * w;
		
		w = ewl_menu_item_new(NULL, (char*) games[i]); // very ugly
		ewl_container_child_append(EWL_CONTAINER(menu),w);
		ewl_callback_append(w,EWL_CALLBACK_SELECT,_new_cb,eap);
		ewl_widget_show(w);
	}
	ewl_widget_show(menu);
	return menu;
}

void _new_cb(Ewl_Widget *w, void *ev_data, void *user_data)
{
	char * text;
	Eli_App * eap;
	
	eap = (Eli_App*) user_data;
	
	text = ewl_menu_item_text_get(EWL_MENU_ITEM(w));
	
	eli_app_new_game(eap,text);
		
	free(text);
}
