#include"Eli_App.h"


int sig_exit_cb(void *data, int ev_type, void *ev);


/* Globals*/

int main(int argc, char **argv)
{
	Eli_App * eap;
	
	/* Initialize NLS */
#ifdef ENABLE_NLS	
	setlocale(LC_MESSAGES, "");
	setlocale(LC_CTYPE, "");
	bindtextdomain(PACKAGE, LOCALE_DIR);
	bind_textdomain_codeset(PACKAGE, "UTF-8");
	textdomain(PACKAGE);
#endif
	/* Initialize Ecore */
	ecore_init();
	/* Initialize Edje */
	edje_init();
	/* Initialize Ecore_Config */
	if (ecore_config_init("elitaire") != ECORE_CONFIG_ERR_SUCC) {
		fprintf( stderr, _("Elitaire Error: Cannot init Ecore_Config") );
		return 1;
	}
	/* Initialize Ewl */
	ewl_init(&argc, argv);
	
	ecore_event_handler_add(ECORE_EVENT_SIGNAL_EXIT, sig_exit_cb, NULL);
	
	eap = 	eli_app_new();
		eli_app_init(eap);
		eli_app_gui_make(eap);
	
	/* ***Main Loop*** */
	ecore_main_loop_begin();
	
	ewl_shutdown();
	//eli_app_gui_del(eap);
	eli_app_del(eap);
	ecore_config_shutdown();
	edje_shutdown();

	ecore_evas_shutdown();

	ecore_shutdown();
	
	return 0;
}

int sig_exit_cb(void *data, int ev_type, void *ev)
{
	ecore_main_loop_quit();
	return 1;
}






