#include<iostream>
#include <cstdlib>
#include <ctime>
#include"playingCard.h"

using namespace std;

char playingCard::getNumValues() {
	
	return myDeck->getNumValues();
}

void cardGame::moveAllUnder(playingCard* pcard, cardStack* tostack)
{
	vector<playingCard*>::const_iterator it, it_end;
	cardStack * fromstack;
	int n;

	fromstack = pcard->myStack;		
	it 	= fromstack->begin();
	it_end 	= fromstack->end();
	
	
	while(*it != pcard) it++;
	n = it_end - it;
	while(it != it_end) tostack->add(*it++);
	while(n--) fromstack->takeCard(); 			
	if(move_card) (*move_card)(pcard);
}
	
bool freeCell::deal()
{
	playingCard * pcard;
	
	for(int i=0 ; i <= cDeck.getNumCards()/8; i++)
	{
		for(int j = 0; j != 8 && (i*8+j) != cDeck.getNumCards();j ++){
			pcard = cDeck.getCard(i*8 + j);
			stacks[j+8]->add(pcard);
			if(move_card)(*move_card)(pcard);
		}
	}
	return true;
}

bool klondike::deal()
{
	int i;
	playingCard * pcard;
	
	for(i=0; i != cDeck.getNumCards(); i++){
		pcard = cDeck.getCard(i);
		stacks[0]->add(pcard);
		if(move_card) (*move_card)(pcard);
		
	}
	for(i=0 ; i != 7; i++)
	{
		for(int j = i; j != 7 ;j ++){
			pcard = stacks[0]->takeCard();
			stacks[j+6]->add(pcard);
			if(move_card)(*move_card)(pcard);
			if(isThoughtful) clickOn(pcard);
		}
	}
	for(i=0;i!=7;i++)clickOn(6+i);
	return true;
}

bool bakersDozen::deal()
{
	playingCard * pcard;
	
	int cardnum = 0;
	int i_stack, i_card;
	for( i_stack = 0 ; i_stack < 4 ; i_stack++)
	{
		for(i_card = 0 ;i_card < 4 ; i_card++)
		{
			pcard = cDeck.getCard(cardnum++);
			stacks[i_stack]->add(pcard);
			if(move_card)(*move_card)(pcard);
		}
	}
	for( i_stack = 8 ; i_stack < 17 ; i_stack++)
	{
		for(i_card = 0 ;i_card < 4 ; i_card++)
		{
			pcard = cDeck.getCard(cardnum++);
			stacks[i_stack]->add(pcard);
			if(move_card)(*move_card)(pcard);
		}
	}
	return true;
}

bool klondike::clickOn0()
{
	cardStack* cs0 = stacks[0];
	cardStack* cs1 = stacks[1];
	playingCard* pcard;
	
	undos.push(new unDoClickOn(0.0,cs0));
	
	if(cs0->empty() && cs1->empty()) return false;
	else if(cs0->empty()) {
		int i = 0;
		while(!cs1->empty()){
			pcard = cs1->takeCard();
			pcard->setVisible(false);
			cs0->add(pcard);
			if(move_card && flip_card){
				(*flip_card)(pcard);
				(*move_card)(pcard);
			}
			i++;
		}
		addPoints((float) i);
	}
	else {
		pcard = cs0->takeCard();
		pcard->setVisible();
		cs1->add(pcard);
		if(flip_card)(*flip_card)(pcard);
		if(move_card)(*move_card)(pcard);
	}
	return true;
}

void klondike::unClickOn0()
{
	cardStack* cs1 = stacks[0];
	cardStack* cs0 = stacks[1];
	playingCard* pcard;
	
	if(cs0->empty() && cs1->empty());
	else if(cs0->empty()) {
		int i = 0;
		while(!cs1->empty()){
			pcard = cs1->takeCard();
			pcard->setVisible();
			cs0->add(pcard);
			if(move_card && flip_card){
				(*flip_card)(pcard);
				(*move_card)(pcard);
			}
			i++;
		}
		addPoints((float) i);
	}
	else {
		pcard = cs0->takeCard();
		pcard->setVisible(false);
		cs1->add(pcard);
		if(move_card)(*flip_card)(pcard);
		if(move_card)(*move_card)(pcard);
	}
}

void unDoClickOn::undo(cardGame* game)
{
	game->unClickOn(clickOn);
	game->addPoints(points);
}

void unDoMove::undo(cardGame* game)
{
	game->moveAllUnder(pcard,fromStack);
	game->addPoints(points);
}

